// global
var jsGraphics;

qx.Class.define("pf.ui.canvas.Canvas",
{
    extend: qx.ui.core.Widget,
    
    construct: function() {
        this.base(arguments);

        var layout = new qx.ui.layout.Grow();
        this._setLayout(layout);
        
        var canvas = new qx.ui.core.Widget();
        canvas.setWidth(1000);
        canvas.setHeight(1000);
        this._add(canvas);
        
        this.addListener("appear", function(e) {
                if (!this.jg) {
                    var element = canvas.getContentElement().getDomElement();
                    this.jg = new jsGraphics(element);
                    // FIXME: get from qx
                    this.jg.ftSz = 12;
                }
            }, this);
    },

    members:
    {
        getJg: function()
        {
            return this.jg;
        },

        clear: function()
        {
            if (this.jg) {
                this.jg.clear();
            }
        },
        
        setColor: function(color)
        {
            if (this.jg && color) {
                this.jg.setColor(color);
            }
        },
        
        setStroke: function(stroke)
        {
            if (this.jg && stroke) {
                this.jg.setStroke(stroke);
            }
        },
        
        paint: function()
        {
            if (this.jg) {
                this.jg.paint();
            }
        },
        
        setPrintable: function(onoff)
        {
            if (this.jg) {
                this.jg.setPrintable(onoff);
            }
        },

        drawString: function(x, y, str, halign, valign, angle)
        {
            var jg = this.jg;
            if (!jg) {
                return 0;
            }
            
            var width  = Math.ceil(0.75*jg.ftSz*str.length);
            var height = jg.ftSz;
            
            switch (halign) {
            case "right":
                x -= width;
                break;
            case "left":
                // no adjustment
                break;
            default:
                x -= (width/2 - 1);
                break;
            }
            
            switch (valign) {
            case "top":
                // no adjustment
                break;
            case "bottom":
                y -= height;
                break;
            default:
                y -= (height/2 + 1);
                break;
            }
            jg.drawStringRect(str, x, y, width, halign, angle);
            
            return width;
        }
    }
});
